// $Id: TestStrStrHashMapSerializer.cs 712730 2008-07-29 06:31:55Z jadixson $
// 
// Copyright 2007-2008 Cisco Systems Inc.
// 
// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy
// of the License at
//  
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations
// under the License.

using System;
using NUnit.Framework;
using Etch.Support;
using Etch.Msg;

namespace Etch.Util
{
    [TestFixture]
    public class TestStrStrHashMapSerializer
    {
        private readonly ValueFactory vf = new DummyValueFactory();

        [TestFixtureSetUp]
        public void First()
        {
            Console.WriteLine();
            Console.Write( "TestStrStrHashMapSerializer" );
        }


        [Test]
        public void TestImport0()
        {
            StrStrHashMap map = new StrStrHashMap();
            TestMap( map );
        }

        [Test]
        public void TestImport1()
        {
            StrStrHashMap map = new StrStrHashMap();
            map.Add( "a", "1" );
            TestMap( map );
        }

        [Test]
        public void TestImport2()
        {
            StrStrHashMap map = new StrStrHashMap();
            map.Add( "a", "1" );
            map.Add( "b", "2" );
            TestMap( map );
        }

        [Test]
        public void TestImport3()
        {
            StrStrHashMap map = new StrStrHashMap();
            map.Add( "a", "1" );
            map.Add( "b", "2" );
            map.Add( "c", "3" );
            TestMap( map );
        }

        // no tests for null keys as string? isn't allowed

        public void TestMap( StrStrHashMap map )
        {
            XType type = new XType( "map" );
		   
            Class2TypeMap class2type = new Class2TypeMap();
		    StrStrHashMapSerializer.Init( type, class2type );
		    ImportExportHelper helper = type.GetImportExportHelper();
    		
		    StructValue sv = helper.ExportValue( vf, map );
    		
		    Assert.AreEqual( sv.GetXType, type );
    		
		    StrStrHashMap map2 = (StrStrHashMap) helper.ImportValue( sv );
    		
            Assert.AreEqual( map, map2 );
        }


    }
}
